#!/usr/bin/env node
"use strict";function _interopDefault(e){return e&&"object"==typeof e&&"default"in e?e.default:e}require("loud-rejection/register"),require("util");var TS=_interopDefault(require("trie-search")),RenderKid=_interopDefault(require("renderkid")),transmutation=require("transmutation"),fs=_interopDefault(require("fs")),unglob=_interopDefault(require("glob")),match=_interopDefault(require("minimatch")),promisify=_interopDefault(require("es6-promisify")),path=require("path"),findUp=_interopDefault(require("find-up")),rollup=require("rollup"),uglifyEs=require("uglify-es"),babel=_interopDefault(require("rollup-plugin-babel")),uglify=_interopDefault(require("rollup-plugin-uglify")),filesize=_interopDefault(require("rollup-plugin-filesize")),nodeResolve=_interopDefault(require("rollup-plugin-node-resolve")),executable=_interopDefault(require("rollup-plugin-executable")),asyncToGenerator=function(e){return function(){var r=e.apply(this,arguments);return new Promise(function(e,t){function n(i,a){try{var o=r[i](a),l=o.value}catch(e){return void t(e)}if(!o.done)return Promise.resolve(l).then(function(e){n("next",e)},function(e){n("throw",e)});e(l)}return n("next")})}},_extends=Object.assign||function(e){for(var r=1;r<arguments.length;r++){var t=arguments[r];for(var n in t)Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n])}return e},createSearcher=({commands:e=[]}={})=>{const r=e.map(e=>{const r=Array.isArray(e.aliases)?e.aliases:[e.aliases];return _extends({},e,{tokens:[e.name,...r].join(" ")})}),t=new TS(["tokens"]);return t.addAll(r),t};const isPromise=e=>!!e&&("object"==typeof e||"function"==typeof e)&&"function"==typeof e.then;var createExecutor=({searcher:e,defaultRenderer:r=console.log})=>t=>{const n=e.get(t[0])[0].run();return isPromise(n)?n.then(r):r(n)};const configureKli=({defaultRenderer:e=console.log}={})=>({commands:r=[]}={})=>{if(!Array.isArray(r))throw new Error("Commands must be an array");if(0===r.length)throw new Error("No commands defined");if(r.forEach(e=>{if("function"!=typeof e.run)throw new Error("All commands must have a run method")}),1===r.length)return{execute:()=>r[0].run()};const t=createSearcher({commands:r});return{execute:createExecutor({searcher:t,defaultRenderer:e})}},kli=configureKli({defaultRenderer:console.log});var kli$1=configureKli({defaultRenderer:console.log}),style={list:{display:"block",marginTop:1},item:{display:"block",marginBottom:1},attr:{display:"block",marginLeft:2},key:{color:"grey",marginRight:1},value:{color:"white"},bar:{display:"block",color:"green"},h1:{display:"block",color:"bright-white",marginLeft:2}};const renderer=new RenderKid;renderer.style(style);var render=({template:e=""}={})=>renderer.render(e);const glob=promisify(unglob),lstat=promisify(fs.lstat),have=e=>r=>match(e,r);var findPackages=({root:e=".",exclude:r=[]}={})=>new Promise((()=>{var t=asyncToGenerator(function*(t,n){try{const i=path.resolve(e,"src/node_modules");if(!(yield lstat(i)).isDirectory)return n("NO");const a=path.resolve(i,"**/package.json");return t((yield glob(a)).filter(function(e){return!r.some(have(e))}).map(function(e){const r=require(e);return{dir:path.dirname(e),name:r.name,bin:r.bin,main:r.main,config:r}}).filter(function(e){return e.name}))}catch(e){return n(e)}});return function(e,r){return t.apply(this,arguments)}})()),findRepoRoot=({anchor:e=".git"}={})=>findUp(e).then(path.dirname);const lstat$1=promisify(fs.lstat);var checkPackages=({packages:e=[]}={})=>new Promise((()=>{var r=asyncToGenerator(function*(r){if(0===e.length)return r([]);return r(yield Promise.all(e.map((()=>{var e=asyncToGenerator(function*(e){if(!e.name)return _extends({},e,{publishable:!1});try{const r=path.resolve(e.dir,"readme.md");if(!(yield lstat$1(r)).isFile)return _extends({},e,{publishable:!1})}catch(r){return _extends({},e,{publishable:!1})}try{if(e.main||!e.bin){const r=path.resolve(e.dir,e.main||"index.js");if(!(yield lstat$1(r)).isFile)return _extends({},e,{publishable:!1})}else if(e.bin){const r=Object.values(e.bin);if((yield Promise.all(r.map(function(r){return path.resolve(e.dir,r)}).map((()=>{var e=asyncToGenerator(function*(e){return lstat$1(e)});return function(r){return e.apply(this,arguments)}})()))).some(function(e){return!e.isFile}))return _extends({},e,{publishable:!1})}}catch(r){return _extends({},e,{publishable:!1})}return _extends({},e,{publishable:!0})});return function(r){return e.apply(this,arguments)}})())))});return function(e){return r.apply(this,arguments)}})()),buildPackages=({configs:e=[]}={})=>Promise.all(e.map(e=>rollup.rollup({input:e.input,external:e.external,plugins:e.plugins}).then(r=>Promise.all(e.output.map(t=>r.write({file:t.file,format:t.format,banner:e.banner})))))),findBaseConfig=({root:e="."}={})=>require(path.resolve(e,"package.json")),formatPackageList=({packages:e=[]}={})=>`\n    <bar>--------------------------------------------------------------------------------</bar>\n    <h1>Package List</h1>\n    <bar>--------------------------------------------------------------------------------</bar>\n    <list>\n        ${e.map(e=>`<item>\n                <attr><key>Name:</key><value>${e.name}</value></attr>\n                <attr><key>Version:</key><value>${e.version||"No version"}</value></attr>\n            </item>`).join("")}\n    </list>\n    `;const babelConfig={babelrc:!1,presets:[["env",{modules:!1,targets:{node:"6"}}],"stage-0"],plugins:["external-helpers"],exclude:["node_modules/**"]};var buildRollupConfigs=({root:e=".",packages:r=[],baseConfig:t={dependencies:{}}}={})=>new Promise(n=>n([].concat(...r.filter(e=>e.bin).filter(e=>e.bin.constructor===Object).map(r=>Object.values(r.bin).map(n=>({input:path.resolve(e,"src/node_modules",r.name,n),external:[...Object.keys(t.dependencies),"fs","path","util"],output:[{file:path.resolve(e,"dist",r.name,n),format:"cjs"}],banner:"#!/usr/bin/env node",plugins:[nodeResolve({customResolveOptions:{moduleDirectory:"src/node_modules"},preferBuiltins:!0}),babel(babelConfig),uglify({},uglifyEs.minify),executable(),filesize()]}))))));const cli=kli$1({commands:[{name:"list",aliases:["ls"],run:()=>transmutation.transmute({}).extend("root",findRepoRoot).extend("exclude",["**/fixtures/**"]).extend("packages",findPackages).extend("template",formatPackageList).extend("output",render).then(transmutation.isolate("output"))},{name:"check",run:()=>transmutation.transmute({}).extend("root",findRepoRoot).extend("baseConfig",findBaseConfig).extend("exclude",["**/fixtures/**"]).extend("packages",findPackages).extend("checkedPackages",checkPackages).then(transmutation.isolate("checkedPackages"))},{name:"build",run:()=>transmutation.transmute({}).extend("root",findRepoRoot).extend("baseConfig",findBaseConfig).extend("exclude",["**/fixtures/**"]).extend("unfiltered",findPackages).extend("packages",({unfiltered:e})=>e.filter(e=>e.bin)).extend("configs",buildRollupConfigs).then(buildPackages)}]});cli.execute(process.argv.slice(2));
